#!/usr/bin/perl

#################################################################
# Alex Carmona Credit Card Processing System   Version 1.050805 #
#################################################################
#                          ACCCPS.CGI                           #
#     Copyrights 2005 Hostwork International (Hostwork.com)     #
#                      All Rights Reserved.                     #
#################################################################
# Order preview: get fields, check tax, calc tax&shipping, display preview
# Order processing: get fields, process CC, display return page

# LICENSE:
# The use of this application is restricted to its licensee only.
# It may not be used on any other site, modified, duplicated,
# published, or distributed without prior written license from
# Hostwork International.
# For more information visit our website or write to: software@hostwork.com

# USER VARIABLES (CAN BE EDITED BY THE WEBMASTER) #
$mailfrom		= "cm\@deathinelvalle.com";	# sender/recipient to use for email
$mailto			= "cm\@deathinelvalle.com";	# sender/recipient to use for email
$orderlogfile	= "dvd-orders.log";				# file used to keep a log of all orders
$previewpage	= "dvd-confirm.htm";			# order confirmation page
$approvedpage	= "card-approved.html";			# card approved return page
$declinedpage	= "card-declined.html";			# card declined return page
$carderrorpage	= "card-error.html";			# card error return page
$price			= 17.99;							# Item price
$taxrate		= 0.0825;						# California tax rate
$debug			= 0;							# Uncomment to enable verbose debug output
# END OF USER VARIABLES

# INITIALISATION #
use CGI; $q = new CGI; $q->import_names('in');
print "Content-type: text/html\n\n";

if ($in::action eq "preview") { &init; &calculate; &showpage; }
elsif ($in::action eq "confirm") { &init; &processcard; &makepage; }
else { print "$action"; exit; }

sub calculate { print "calculate - " if ($debug);
 ($shiprate, $shipto) = split(/\;/,$in::country);
 $subtotal	= sprintf("%.2f",($price * $in::quantity));
 $shipping	= sprintf("%.2f",($shiprate));
 $tax		= sprintf("%.2f",($subtotal * $taxrate)) if (($shipto eq "United States") && (substr(lc($in::state),0,2) eq "ca"));
 $tax		= "0.00" unless ($tax);
 $total		= sprintf("%.2f",($subtotal + $shipping + $tax));
}

sub processcard { print "processcard - " if ($debug);
 use LWP::UserAgent;
 use Crypt::SSLeay;
 my $ua = new LWP::UserAgent;
 my $remote_url = 'https://www.eProcessingNetwork.Com/cgi-bin/tdbe/transact.pl';
 my $request = new HTTP::Request( 'POST', $remote_url );
 $request->content_type( 'application/x-www-form-urlencoded' );
 $stg = "ePNAccount=0405170&CardNo=$in::ccnum&ExpMonth=$in::ccmonth&ExpYear=$in::ccyear&Total=$in::total&Address=$in::ccaddress&Zip=$in::cczip&EMail=$in::ccemail&CVV2=$in::cvv2&CVV2Type=$in::cvv2type&HTML=No&ItemDesc=$in::description";
 $request->content( $stg ); my $response = $ua->request($request);
 @response = split( /,/, $response->content ); # split into array
 @response[0] =~ s/["]//g; # remove quotes;
 @response[1] =~ s/["]//g; # remove quotes;
 @response[2] =~ s/["]//g; # remove quotes;
 $approval = substr( @response[0], 0, 1 );
 if ($approval eq 'Y') { $returnpage = $approvedpage;
  $data = "Receipt: $ordernum <BR>" . substr(@response[0],1,16) . "<br>AVS Response: " . @response[1] . "<br>CVV2 Response: " . @response[2];
  &saveorder; $emailorder; }
 elsif ($approval eq 'N') { $returnpage = $declinedpage; $data = substr(@response[0],1) . "<br>AVS Response: " . @response[1] . "<br>CVV2 Response: " . @response[2]; }
 else { $returnpage = $carderrorpage; $data = substr(@response[0],1) . "<br>AVS Response: " . @response[1] . "<br>CVV2 Response: " . @response[2]; }
}

sub processcardtest { print "processcard - " if ($debug);
 $stg = "ePNAccount=0405170&CardNo=$in::ccnum&ExpMonth=$in::ccmonth&ExpYear=$in::ccyear&Total=$in::total&Address=$in::ccaddress&Zip=$in::cczip&EMail=$in::ccemail&CVV2=$in::cvv2&CVV2Type=$in::cvv2type&HTML=No&ItemDesc=$in::description";
 $data = $stg; $returnpage = $declinedpage;
}

sub saveorder { print "saveorder - " if ($debug);
 open (LOG,">>$orderlogfile") || die "Error opening logfile $orderlogfile";
 print LOG "$ordernum|DVD|$in::quantity|$subtotal|$tax|$shipping|$total|$authorization|$in::first|$in::last|$in::address|$in::city|$in::state|$in::zip|$shipto|$in::phone|$in::email|$ENV{'REMOTE_ADDR'}\n";
 close(LOG);
}

sub sendnotice { print "sendnotice - " if ($debug);
 open(NOTICE,"|/usr/sbin/sendmail -t") || die "An error occured and the order could not be emailed: $!\nPlease inform <A HREF=\"mailto:$mailto?Subject=Order%20$ordernum\">$mailto</A> of this error to make sure your order doesn't get lost.";
 print NOTICE "From: $in::email\n";
 print NOTICE "To: $mailto\n";
 print NOTICE "Subject: [DIEV] DVD Order $ordernum\n\n";
 print NOTICE "The following order has been received:\n\n";
 print NOTICE "  Number: $ordernum\n";
 print NOTICE "    Item: $in::quantity DVD$plural\n";
 print NOTICE "Subtotal: $subtotal\n";
 print NOTICE "     Tax: $tax\n";
 print NOTICE "Shipping: $shipping\n";
 print NOTICE "   Total: $total\n";
 print NOTICE " CC Auth: $authorization\n\n";
 print NOTICE "Customer Information:\n\n";
 print NOTICE "    Name: $in::first $in::last\n";
 print NOTICE " Address: $in::address\n";
 print NOTICE "Address2: $in::city, $in::state $in::zip\n";
 print NOTICE " Country: $shipto\n";
 print NOTICE "   Phone: $in::phone\n";
 print NOTICE "   Email: $in::email\n\n";
 print NOTICE "The order was submitted from the following IP address: $ENV{'REMOTE_ADDR'}\n";
 print NOTICE "\n.\n";
 close(NOTICE);
}

sub showpage { print "showpage - " if ($debug);
 open (PAGE, "<$previewpage") || die "Error retrieving template from $previewpage";
 while ($string = <PAGE>) {
  $string =~ s/-DESCRIPTION-/$in::quantity DVD$plural/;
  $string =~ s/-QUANTITY-/$in::quantity/;
  $string =~ s/-PRICE-/$price/;
  $string =~ s/-SUBTOTAL-/$subtotal/;
  $string =~ s/-SHIPPING-/$shipping/;
  $string =~ s/-TOTAL-/$total/;
  $string =~ s/-TAX-/$tax/;
  $string =~ s/-SHIPPING-/$shipping/;
  $string =~ s/-TOTAL-/$total/;
  $string =~ s/-FIRST-/$in::first/;
  $string =~ s/-LAST-/$in::last/;
  $string =~ s/-ADDRESS-/$in::address/;
  $string =~ s/-CITY-/$in::city/;
  $string =~ s/-STATE-/$in::state/;
  $string =~ s/-ZIP-/$in::zip/;
  $string =~ s/-COUNTRY-/$shipto/;
  $string =~ s/-PHONE-/$in::phone/;
  $string =~ s/-EMAIL-/$in::email/;
  $string =~ s/-CCFIRST-/$in::ccfirst/;
  $string =~ s/-CCLAST-/$in::cclast/;
  $string =~ s/-CCADDRESS-/$in::ccaddress/;
  $string =~ s/-CCCITY-/$in::cccity/;
  $string =~ s/-CCSTATE-/$in::ccstate/;
  $string =~ s/-CCZIP-/$in::cczip/;
  $string =~ s/-CCCOUNTRY-/$in::cccountry/;
  $string =~ s/-CCPHONE-/$in::ccphone/;
  $string =~ s/-CCEMAIL-/$in::ccemail/;
  $string =~ s/-CCNUM-/$in::ccnum/;
  $string =~ s/-CCMONTH-/$in::ccmonth/;
  $string =~ s/-CCYEAR-/$in::ccyear/;
  $string =~ s/-CVV2-/$in::cvv2/;
  $string =~ s/-CVV2TYPE-/$in::cvv2type/;
  print $string; }
 close(PAGE);
}

sub makepage { print "makepage - " if ($debug);
 open (PAGE, "<$returnpage") || die "Error retrieving template ftom $returnpage";
 while ($string = <PAGE>) {
  $string =~ s/-DATA-/$data/;
  print $string; }
 close(PAGE);
}

sub init { print "init - " if ($debug);
 $plural = "s" if ($in::quantity gt 1);
 @months = ('01','02','03','04','05','06','07','08','09','10','11','12');
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
 if ($mday < 10) { $mday = "0$mday"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($min < 10) { $min = "0$min"; }
 if ($sec < 10) { $sec = "0$sec"; }
 $year += 1900 ;
 $date = "$months[$mon]/$mday/$year";
 $ordernum = "$year$months[$mon]$mday$hour$min$sec";
}      

exit;
